.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm	; get them from http://www.masm32.com/board/index.php?topic=770.0
LOOP_COUNT	= 1000000

Smooth MACRO		; put before the algo_s label
	align 16
	REPEAT 16		; aligns and inserts some int3 to reassure the
		INT 3		; CPU that there is nothing to cache above the algo
	ENDM
ENDM

testme MACRO algo, comment
LOCAL ct
  invoke Sleep, 100
  counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
  	ct = 0
  	REPEAT 10
	  	ct = ct + 1
  		@CatStr(<push offset decstr>, %ct)
		call algo
	ENDM
  counter_end
  ifb <comment>
	print str$(eax), 9, "cycles for 10*&algo&", 13, 10
  else
	print str$(eax), 9, "cycles for 10*&comment&", 13, 10
  endif
ENDM

testcorrect MACRO algo
	push offset decstring
	call algo
	.if eax!=7FFFFFFFh
		print hex$(eax), 9, "ERROR in &algo&", 13, 10
	.endif
ENDM

codesize MACRO algo
  mov eax, &algo&_endp
  sub eax, &algo&_s
  print str$(eax), 9, " bytes for &algo&", 13, 10
ENDM

.data						; ############### TESTSTRINGS ###############
MyOffset = 9999
decstring	db "2147483647", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr1	db "-2147483647", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr2	db "-2147483647", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr3	db "2147483647", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr4	db "-2147483647", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr5	db "2147483647", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr6	db "2147483647", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr7	db "2147483647", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr8	db "-12345678", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr9	db "-0123456789", 0
ORG $+MyOffset				; make sure they sit on different cache lines
decstr10	db "12345678", 0

.code						; ############### Get timings and code size ###############
start:
	push 1
	call ShowCpu						; print brand string and SSE level
	testcorrect atolsL					; test if algos deliver correct results
	testcorrect atol_2
	testcorrect atol

	REPEAT 2								; the timings
		testme atolsL						; if no second arg is present, the algo's original name will be shown
		testme atol_2
		testme atol
		print chr$(13, 10)
	ENDM

	print "Code size:", 13, 10		; code sizes
	codesize atolsL
	codesize atol_2
	codesize atol


	inkey chr$(13, 10, "--- ok ---", 13)
	exit


; ###################### THE ALGOS #######################
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

Smooth
atol_s:     ; start label
atol proc String:DWORD
  ; ------------------------------------------------
  ; Convert decimal string into UNSIGNED DWORD value
  ; ------------------------------------------------
      xor eax, eax
    mov edx, [esp+4]            ; lpSrc
    movzx ecx, BYTE PTR [edx]
    add edx, 1

    cmp ecx, "-"
    jne lbl0
    add eax, 1
    movzx ecx, BYTE PTR [edx]
    add edx, 1
  lbl0:
    mov [esp+4], eax            ; keep sign on stack
    xor eax, eax
    sub ecx, 48
    jc  lbl2

  lbl1:
  REPEAT 4
    lea eax, [eax+eax*4]        ; mul by 5
    lea eax, [ecx+eax*2]        ; then mul by 2
    movzx ecx, BYTE PTR [edx]
    add edx, 1
    sub ecx, 48
    jc  lbl2
  ENDM

    lea eax, [eax+eax*4]        ; mul by 5
    lea eax, [ecx+eax*2]        ; then mul by 2
    movzx ecx, BYTE PTR [edx]
    add edx, 1
    sub ecx, 48
    jnc  lbl1

  lbl2:
    mov ecx, [esp+4]            ; retrieve sign
    test ecx, ecx
    jz lbl3
    neg eax                     ; negative return value is sign set
  lbl3:
     ret 4
atol endp
atol_endp:     ; out label

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; 
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

Smooth
align 16
db 3 dup(0)
atolsL_s:
atolsL proc ; String:DWORD
	pop			ecx
	pop			edx
    movzx		eax,  byte ptr [edx]
    cmp			eax, 2Dh
	jb				@f
	movzx		ecx,  byte ptr [edx+1]
	je				Vil2
	test			ecx, ecx
    je				Vil12
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h*11]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+2]
     je			@f 
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+3]
     je			@f
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+4]
	 je			@f
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+5]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+6]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+7]
     jz			@f 
	  lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+8]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+9]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	jmp			dword ptr [esp-2*4]
Vil12:
	 sub			eax, 30h
@@:
	jmp			dword ptr [esp-2*4]
	db			12 dup(0)
Vil2:
	 test			ecx, ecx
     jz			Vil4 ;@f	-4
	 mov		eax, ecx
	 movzx	ecx,  byte ptr [edx+2]
	 test			ecx, ecx
     jz			Vil4a ;@f	-4
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h*11]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+3]
     jz			@f 
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+4]
     jz			@f
     lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+5]
     jz			@f
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+6]
     jz			@f
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+7]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+8]
     jz			@f 
	  lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+9]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	 xor			ecx, ecx
	 add			cl,  byte ptr [edx+10]
     jz			@f 
	 lea			eax, [eax+eax*4]
     lea			eax, [ecx+eax*2-30h]
	neg			eax
	jmp			dword ptr [esp-2*4]
Vil4:
	xor			eax, eax
	jmp			dword ptr [esp-2*4]
Vil4a:
	 sub			eax, 30h
	 nop
 @@:
	neg			eax
	jmp			dword ptr [esp-2*4]	
atolsL endp
atolsL_endp:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; 
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

Smooth
atol_2_s:
atol_2 proc  pszSrc: ptr BYTE

mov edx,[esp+4] ;pszSrc
	movzx ecx,BYTE ptr [edx]
	test ecx,ecx
	jz @err
	cmp ecx,'-'
	jz @2
		lea eax,[ecx-'0']
		cntr = 1
		REPEAT 9
			movzx ecx,BYTE ptr [edx+cntr]
			test ecx,ecx
		@@:	jnz @F
			ret 4
		@@:
			lea eax,[eax*4+eax]
			lea eax,[eax*2+ecx-'0']
			cntr = cntr + 1
		ENDM
		ret 4

	align 16
@2:
		movzx ecx,BYTE ptr [edx+1]
		test ecx,ecx
		jz @fin2
		lea eax,[ecx-'0']
		cntr = 2
		REPEAT 9
			movzx ecx,BYTE ptr [edx+cntr]
			test ecx,ecx
			jz @fin2
			lea eax,[eax*4+eax]
			lea eax,[eax*2+ecx-'0']
			cntr = cntr + 1
		ENDM
		;align 16
	@fin2:
		neg eax
		ret 4
	
	align 16
@err:
	ret 4
  
atol_2 endp
atol_2_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
; 


ShowCpu proc
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start


